include get.e       -- for wait_key()
include graphics.e  -- for get_position()

constant
    BACKSPACE   = 8,
    ENTER       = 13,
    ESC         = 27,
    FILL_CHAR   = 249

global function input( integer size )
    
    -- get text from user at current position
    -- maximum length is size

    integer row, col, key    
    sequence at, text

    -- get the current position
    at = get_position()
    row = at[1]
    col = at[2]

    -- set text
    text = ""
    
    -- main loop
    while 1 do
    
        -- show the text
        position( row, col )

        -- border
        puts( 1, "["                                    -- left border
            & text                                      -- data
            & repeat( FILL_CHAR, size - length(text) )  -- filler
            & "]" )                                     -- right border

        -- position cursor
        position( row, col+length( text )+1 )
    
        -- get a key
        key = wait_key()
    
        -- process the key        
        if key = ESC then  
            
            text = ""
            exit
        elsif key = ENTER then
            exit
        elsif key = BACKSPACE then
            -- handle backspace
            if length( text ) > 0 then
                -- remove the last character from the text
                text = text[1..length(text)-1]
            end if
            
        elsif key >= ' '        
        and   key <= '~' then  
            -- handle "normal" key
            if length( text ) < size then
                text = text & key
            end if
            
        else
            -- ignore key
            
         end if
    end while

    return text
    
end function



